<?php defined('SYSPATH') or die('No direct script access.');

class Controller_UserEnvironment extends Controller
{
    protected $SemesterInfo;

    /** @var User */
    protected $user;

    public function before() {
        $this->user = User::instance();
        if (!$this->user->isSignedIn()) {
            $this->redirect('sign', 302);
            return;
        }

        $semester = Model_Semesters::getInfo($this->user->SemesterID);
        // $semester['Num'] = $semester['Num'] == 1 ? 'Осень' : 'Весна';
        if ($semester['Num'] == 1) {
            $semester['Num'] = 'Осень';
        } else {
            $semester['Num'] = 'Весна';
            $semester['Year']++;
        }
        $this->SemesterInfo = $semester;

        if ($this->user->Type == 'student') {
            //unified degree from db
            $uniDegree = $this->user['Degree'];
            $this->user['Degree'] = Model_Grades::getDegreeTitle($uniDegree);
        }
        // Проверка на доступ к странице
        $route = Route::name($this->request->route());
        $userMark = $this->user->RoleMark;
        $sysModel = new Model_System;
        $bitmask = (int)$sysModel->getBitmaskForRoute($route);
        if ($bitmask === 0) {
            $bitmask = (int)1;
        }
        if ($userMark === 0) {
            $userMark = (int)1;
        }
        if (!($bitmask & $userMark)) {
            throw HTTP_Exception::factory(403, 'Не пытайтесь попасть туда, куда попадать не следует.');
        }
    }

    public function action_index() {
        $type = $this->user->Type;
        $page = Request::factory($type . '/index')->execute();
        $this->response->body($page);
    }

    public function action_profile() {
        if ($this->user->Type != 'teacher') {
            $this->redirect('/', 302);
        } else {
            $url = "teacher/profile";
            $page = Request::factory($url)->execute();
            $this->response->body($page);
        }
    }

    public function action_settings() {
        $page = Request::factory($this->user->Type . '/settings')->execute();
        $this->response->body($page);
    }
}
